#include <stdint.h>
#include <stm32f4xx.h>

#ifndef EXTI_H
#define EXTI_H

typedef struct {
  EXTI_TypeDef* exti;
  SYSCFG_TypeDef* syscfg;
  uint8_t line;
} exti_t;

void exti_init(exti_t* exti, uint8_t line, EXTI_TypeDef* exti_periph, SYSCFG_TypeDef* syscfg);
void exti_external_interrupt(exti_t* exti, uint8_t gpio);

// Only 21 positions are now supported. This is too hard for other ones.
void exti_rising_interrupt(exti_t* exti);
void exti_falling_interrupt(exti_t* exti);
void exti_disable_interrupt(exti_t* exti);
void exti_enable_interrupt(exti_t *exti);

void exti_nvic_setup(exti_t* exti, uint8_t line);

uint32_t exti_is_interrupt(exti_t* exti);
void exti_clear_interrupt(exti_t* exti);

#endif // EXTI_H
